var errors = {
    no_subsystem : "Ni podsistemov!",
    hwi_lwi_error : "Hwi ali Lwi sta v napačnem formatu ali prazna!",
	custom_q_error : "Prosim vnesite število!",
	custom_q_too_low : "Prosim vnesite vrednost večjo od 1.0!",
	custom_q_too_high : "Prosim vnesite vrednost manjšo od 10.0!",
    unknown : "Neznana napaka!",
	error : "Napaka!"
};
	//constructionSystemNames
var structuralTypeNames = {
        //betonske stavbe
		s1 : "Enoetažni okvirni sistem ali mešani sistem ekvivalenten okvirnemu",
		s2 : "Večetažni okvirni sistem z enim poljem ali mešani sistem ekvivalenten okvirnemu",
		s3 : "Večetažni okvirni sistem z več polji ali mešani sistem ekvivalenten okvirnemu",
		s4 : "Sistem povezanih sten (z odprtinami) ali mešani sistem ekvivalenten stenastemu",
		s5 : "Sistem nepovezanih (konzolnih) sten s samo 2 nepovezanima stenama v V smeri",
		s6 : "Drugi stenasti sistemi z nepovezanimi stenami",
		s7 : "Tozijsko podajni sistemi",
		s8 : "Sistemi obrnjenega nihala",
		//jeklene stavbe
		s9 : "Pomični enoetažni okviri",
		s10 : "Pomični večetažni okviri čez eno polje",
		s11 : "Pomični večetažni okviri čez več polj",
		s12 : "Okviri z centričnimi povezji z nateznimi diagonalami",
		s13 : "Okviri s centričnimi V povezji",
		s14 : "Okviri z ekcentričnimi povezji",
		s15 : "Konstrukcije obrnjenega nihala; območje sipanja ob dnu stebrov",
		s16 : "Konstrukcije obrnjenega nihala; območje sipanja v stebrih",
		s17 : "Konstrukcije z betonskimi jedri",
		s17_1: "Sistem povezanih sten (z odprtinami) ali mešani sistem ekvivalenten stenastemu",
		s17_2: "Sistem nepovezanih (konzolnih) sten s samo 2 nepovezanima stenama v V smeri",
		s17_3: "Drugi stenasti sistemi z nepovezanimi stenami",
		s18 : "Pomični okviri, kombinirani s centričnimi povezji",
		s19 : "Pomični okiviri, komb. z bet. ali zid. polnilom, ki ni spojeno z okv., vendar v stiku z polnilom",
		s20 : "Pomični okiri kombinirani z z AB polnilom, spojeno z okvirjem",
		s21 : "Pomični enoetažni okviri kombinirani s polnili izoliranimi od okvira",
		s22 : "Pomični večetažni okviri čez eno polje kombinirani s polnili izoliranimi od okvira",
		s23 : "Pomični večetažni okviri čez več polj kombinirani s polnili izoliranimi od okvira",
		//sovprezne stavbe
		s24 : "Pomični enoetažni okviri",
        s25 : "Pomični večetažni okviri čez eno polje",
        s26 : "Pomični večetažni okviri čez več polj",
        s27 : "Okviri z centričnimi povezji z nateznimi diagonalami",
        s28 : "Okviri s centričnimi V povezji",
        s29 : "Okviri z ekcentričnimi povezji",
        s30 : "Konstrukcije obrnjenega nihala; območje sipanja ob dnu stebrov",
        s31 : "Konstrukcije obrnjenega nihala; območje sipanja v stebrih",
        s32 : "Sovprežne stene; jeklen ali sovprežen okvir z betonskim polnilom",
        s33 : "Sovprežne stene, ojačane z robnimi navpičnimi jeklenimi elementi",
        s34 : "Sovprežne ali betonske stene, povezane z jeklenimi ali sovprežnimi nosilci",
        s35 : "Sovprežne strižne stene z jekleno ploščo",
        //lesene stavbe
        s36 : "Konzole, grede, dvo in tričlenski loki",
        s37 : "Paličja, povezana z spojniki",
        s38 : "Lepljeni stenski paneli z lepljenimi diafragmami, povezani z žeblji ali vijaki z maticami",
        s39 : "Paličja z mozničenimi ali vijačenimi spoji (spoji s sorniki)",
        s40 : "Mešane konstrukcije iz lesenega okvira (ki prenaša vodoravne sile) in nenosilnega polnila",
        s41 : "Statično nedoločeni portalni okviri z mozničenimi ali vijačenimi spoji - spoji s sorniki",
        s42 : "Žebljani stenski paneli z lepljenimi diafragmami, povezani z žeblji ali z vijaki z maticami ",
        s43 : "Paličja z žebljanimi vozlišči",
        s44 : "Statično nedoločeni portalni okviri z mozničenimi ali vijačenimi spoji - spoji s sorniki",
        s45 : "Žebljani stenski  paneli z žebljanimi diafragamami, povezani z žeblji in vijaki z maticami ",
        //zidane stavbe
        s46 : "Nearmirano zidovje, ki izpolnjuje samo zahteve EN 1996",
        s47 : "Nearmirano zidovje, ki izpolnjuje zahteve EN 1998-1",
        s48 : "Povezano zidovje",
        s49 : "Armirano zidovje"
};


var materials = {
		rc : 0,
		ss : 1,
		cs : 2,
		ts : 3,
		ms : 4
};
	//ductilities
var ductility = {
		dcl : 0,
		dcm : 1,
		dch : 2
};

	//constructionSystems = initConsSystems();
var structuralTypes = initStructTypes();
	//constrSubsystems = initConstrSubystem
var structSubTypes = initStructSubTypes();


// This function goes through the options for the given
// drop down box and removes them in preparation for
// a new set of values

function emptyList( box ) {
	// Set each option to null thus removing it
	while ( box.options.length ) box.options[0] = null;
}

// This function assigns new drop down options to the given
// drop down box from the list of lists specified

function fillList( box, arr, setStartPos ) {

    var selectedIndex = box.selectedIndex;

   // Next empty the slave list
	emptyList( box );

	for ( i = 0; i < arr.length; i++ ) {

		// Create a new drop down option with the
		// display text and value from arr
	    var sType = arr[i];
	    var value = getRefQValue(sType, box.form);
	    option = new Option(sType.name, value);

	    // Add to the end of the existing options

	    box.options[box.length] = option;
	}

	// Preselect option 0 if option specified
    if(setStartPos != null && setStartPos == true)
    {
	    box.selectedIndex=0;
	}
	else
	{
	    //else restore previous selection
	    box.selectedIndex = selectedIndex;
	}
}
		//getDuctilityValue
function getRefQValue(sType, form)
{
    if(sType.values == null)
    {
        return -1;
    }
    
    if(!form.ElevationRegular.checked)
    {
        var adjustFactor = 0.8;
        var q;
        if(form.PlanRegular.checked)
        {
            q = sType.values.plRegular;
        }
        else
        {
            q = sType.values.plNotRegular;
        }
        
        q = q*adjustFactor;
        if(q < 1.5)
        {
            q = 1.5;
        }
        return q;
    }
    else
    {
        if(form.PlanRegular.checked)
        {
            return sType.values.plRegular;
        }
        else
        {
            return sType.values.plNotRegular;
        }
    }
}

// This function performs a drop down list option change by first
// emptying the existing option list and then assigning a new set

function changeList( box, setStartPos ) {
	// Isolate the appropriate list by using the value
	// of the currently selected option
	
	//prepareForm(box.form);
	
	var list;
    var ductilityIndex = box.form.Ductility.value;
    
    list = structuralTypes[box.selectedIndex][ductilityIndex].slice(0);

	// Then assign the new list values

	fillList( box.form.slave, list, setStartPos );
	
	//configure form properly
	setUpForm(box.form);
}
//sets up form correctly for selected item
function setUpForm(form)
{
    var strucTypes = form.slave;
    var strucTypeName = strucTypes.options[strucTypes.selectedIndex].innerHTML;

    //ce so betonski sistemi in je izbran sistem med S4 in S7
    if(form.master.selectedIndex == materials.rc && 
            (strucTypeName == structuralTypeNames.s4 || 
             strucTypeName == structuralTypeNames.s5 ||
             strucTypeName == structuralTypeNames.s6 || 
             strucTypeName == structuralTypeNames.s7))
    {
        showSubstructuralsDiv();
        hideSubstructuralsSelect();
		clearNotices();
    }
    else if(strucTypes.options[strucTypes.selectedIndex].value == -1)
    {
        //selected system type doesnt have proper ductility values
        var ductilityIndex = form.Ductility.value;
        //if there is an invalid value search for subsystems
        var list = structSubTypes[strucTypeName][form.Ductility.value];
        
        if(list == null)
        {
            //error - no subsystem
            writeError(errors.no_subsystem);
            //disable calculate factor button
            form.CalcFactor.disabled = true;
        }
        else
        {
            //show available subsystems
            showSubstructuralsDiv();
            showSubstructuralsSelect();
            fillList(form.SubStruct, list);
            form.CalcFactor.disabled = false; 
            clearNotices();
        }
    }
    else
    {
        hideSubstructuralsDiv();
        hideSubstructuralsSelect();
        form.CalcFactor.disabled = false;
        clearNotices();
    }
    
    if(form.master.selectedIndex == materials.ts && 
        (   (strucTypeName == structuralTypeNames.s44
                && form.Ductility.selectedIndex == ductility.dch) ||
            (strucTypeName == structuralTypeNames.s45 
                && form.Ductility.selectedIndex == ductility.dch)
        )
      )
    {
        //show requirement div if wooden systems are selected 
        //and either s44 or s45 is selected
        showRequirement();
    }
    else
    {
        hideRequirement();
    }
	

}
//handler called when another construction system is selected
function onStructuralTypeSelect(form)
{
    setUpForm(form);
}

//
function calculateQFactor(form)
{
    var qFactor;
    var substructuralsDiv = $("#substructuralsSelect:visible");
    var index;
    if(substructuralsDiv.length)
    {
        //podatke jemljemo iz selecta podsistemov
        index = form.SubStruct.selectedIndex;
    
        qFactor = form.SubStruct[index].value;
    }
    else
    {
        //podatke jemljemo iz selecta konstrukcijskih sistemov
        index = form.slave.selectedIndex;
    
        qFactor = form.slave.options[index].value;
    }
    qFactor = Number(qFactor);
    
    if(isWallStructure(form))
    {
        //izracunaj se k_w
        var lwi = form.L.value;
        var hwi = form.H.value;
        
        if(lwi == "" || hwi == "" || 
            isNaN(lwi) || isNaN(hwi)|| 
		   lwi <= 0 || hwi <= 0)
        {
            writeError(errors.hwi_lwi_error);
            return;
        }
        lwi = Number(lwi);
        hwi = Number(hwi);
        var k_w = (1+(hwi/lwi))/3;
        
        if(k_w < 0.5)
           k_w = 0.5;
        if(k_w > 1)
           k_w = 1;
            
        qFactor = qFactor*k_w;
		   
    }
    
    if(qFactor < 1.5)
        qFactor = 1.5;
    
    qFactor = qFactor.toFixed(2);   //zaokrozi na 2 decimalki
    $("#behaviourEC8").html(qFactor);
    form.R.value = qFactor;
    
   drawSpectrum();
}

function customQ()
{
	var numQ=Number($("#qVal").val());
	
    if(numQ < 1)
    {
        writeError(errors.custom_q_too_low);
        return; 
	}
	
	    if(numQ > 10)
    {
        writeError(errors.custom_q_too_high);
        return; 
	}

        if(numQ == "" || isNaN(numQ))
    {
        writeError(errors.custom_q_error);
        return;
    }

	$("#qVal").val(formatNumber(numQ, 2, true))
	

	
	drawSpectrum();
}

/**
* if a parameter is changed q input and spectrum graph must be cleared
* to avoid confusion
*/
function qParameterChanged()
{
	clearNotices();
}


function initStructTypes(){
	//initialise
	var num_of_materials = getJsonLength(materials);
	var structural_types = new Array(num_of_materials);

    var num_of_ductility = getJsonLength(ductility);
	for(var m=0; m < structural_types.length; m++){
		structural_types[m] = [num_of_ductility];
	}
	
	//rc - betonske stavbe
	structural_types[materials.rc][ductility.dcl] = [
						new StructuralType(structuralTypeNames.s1, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s2, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s3, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s4, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s5, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s6, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s7, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s8, new RefQValues(1.5, 1.5))
						];														  
    structural_types[materials.rc][ductility.dcm] = [
						new StructuralType(structuralTypeNames.s1, new RefQValues(3.3, 3.152)),
						new StructuralType(structuralTypeNames.s2, new RefQValues(3.6, 3.3)),
						new StructuralType(structuralTypeNames.s3, new RefQValues(3.9, 3.45)),
						new StructuralType(structuralTypeNames.s4, new RefQValues(3.6, 3.3)),
						new StructuralType(structuralTypeNames.s5, new RefQValues(3, 3, 2.4)),
						new StructuralType(structuralTypeNames.s6, new RefQValues(3, 3)),
						new StructuralType(structuralTypeNames.s7, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s8, new RefQValues(1.5, 1.5))
						];														  
    structural_types[materials.rc][ductility.dch] = [
						new StructuralType(structuralTypeNames.s1, new RefQValues(4.95, 4.725)),
						new StructuralType(structuralTypeNames.s2, new RefQValues(5.4, 4.95)),
						new StructuralType(structuralTypeNames.s3, new RefQValues(5.85, 5.175)),
						new StructuralType(structuralTypeNames.s4, new RefQValues(5.4, 4.95)),
						new StructuralType(structuralTypeNames.s5, new RefQValues(4, 4, 3.2)),
						new StructuralType(structuralTypeNames.s6, new RefQValues(4.4, 4.2)),
						new StructuralType(structuralTypeNames.s7, new RefQValues(3, 3)),
						new StructuralType(structuralTypeNames.s8, new RefQValues(2, 2))
						];
    //ss - jeklene stavbe
    structural_types[materials.ss][ductility.dcl] = [
						new StructuralType(structuralTypeNames.s9, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s10, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s11, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s12, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s13, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s14, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s15, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s16, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s17, null),
						new StructuralType(structuralTypeNames.s18, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s19, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s20, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s21, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s22, new RefQValues(1.5, 1.5)),
						new StructuralType(structuralTypeNames.s23, new RefQValues(1.5, 1.5))
						];
    structural_types[materials.ss][ductility.dcm] = [
						new StructuralType(structuralTypeNames.s9, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s10, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s11, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s12, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s13, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s14, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s15, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s16, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s17, null),
						new StructuralType(structuralTypeNames.s18, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s19, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s20, new RefQValues(3.3, 3.15)),
						new StructuralType(structuralTypeNames.s21, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s22, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s23, new RefQValues(4, 4))
						];
    structural_types[materials.ss][ductility.dch] = [
						new StructuralType(structuralTypeNames.s9, new RefQValues(5.5, 5.25)),
						new StructuralType(structuralTypeNames.s10, new RefQValues(6, 5.5)),
						new StructuralType(structuralTypeNames.s11, new RefQValues(6.5, 5.75)),
						new StructuralType(structuralTypeNames.s12, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s13, new RefQValues(2.5, 2.5)),
						new StructuralType(structuralTypeNames.s14, new RefQValues(6, 5.5)),
						new StructuralType(structuralTypeNames.s15, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s16, new RefQValues(2.2, 2.1)),
						new StructuralType(structuralTypeNames.s17, null),
						new StructuralType(structuralTypeNames.s18, new RefQValues(4.8, 4.4)),
						new StructuralType(structuralTypeNames.s19, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s20, new RefQValues(4.4, 4.2)),
						new StructuralType(structuralTypeNames.s21, new RefQValues(5.5, 5.25)),
						new StructuralType(structuralTypeNames.s22, new RefQValues(6, 5.5)),
					    new StructuralType(structuralTypeNames.s23, new RefQValues(6.5, 5.75))
						];
														  
    //cs - sovprezne stavbe
    structural_types[materials.cs][ductility.dcl] = [
					  	new StructuralType(structuralTypeNames.s24, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s25, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s26, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s27, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s28, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s29, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s30, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s31, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s32, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s33, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s34, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s35, new RefQValues(1.5, 1.5))
						];
    structural_types[materials.cs][ductility.dcm] = [
						new StructuralType(structuralTypeNames.s24, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s25, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s26, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s27, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s28, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s29, new RefQValues(4, 4)),
						new StructuralType(structuralTypeNames.s30, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s31, new RefQValues(2, 2)),
						new StructuralType(structuralTypeNames.s32, new RefQValues(3.3, 3.15)),
						new StructuralType(structuralTypeNames.s33, new RefQValues(3.3, 3.15)),
						new StructuralType(structuralTypeNames.s34, new RefQValues(3.3, 3.15)),
						new StructuralType(structuralTypeNames.s35, new RefQValues(3.6, 3.3))
						];
    structural_types[materials.cs][ductility.dch] = [
		  			    new StructuralType(structuralTypeNames.s24, new RefQValues(5.5, 5.25)),
					    new StructuralType(structuralTypeNames.s25, new RefQValues(6, 5.5)),
					    new StructuralType(structuralTypeNames.s26, new RefQValues(6.5, 5.75)),
					    new StructuralType(structuralTypeNames.s27, new RefQValues(4, 4)),
					    new StructuralType(structuralTypeNames.s28, new RefQValues(2.5, 2.5)),
					    new StructuralType(structuralTypeNames.s29, new RefQValues(6, 5.5)),
					    new StructuralType(structuralTypeNames.s30, new RefQValues(2, 2)),
					    new StructuralType(structuralTypeNames.s31, new RefQValues(2.2, 2.1)),
					    new StructuralType(structuralTypeNames.s32, new RefQValues(4.4, 4.2)),
					    new StructuralType(structuralTypeNames.s33, new RefQValues(4.4, 4.2)),
					    new StructuralType(structuralTypeNames.s34, new RefQValues(4.95, 4.725)),
					    new StructuralType(structuralTypeNames.s35, new RefQValues(4.8, 4.4))
						];
    //ts - lesene stavbe
    structural_types[materials.ts] = generateTsTypes(null);
   
    //ms - zidane stavbe						  
    structural_types[materials.ms][ductility.dcl] = [
					  	new StructuralType(structuralTypeNames.s46, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s47, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s48, new RefQValues(2, 2)),
					  	new StructuralType(structuralTypeNames.s49, new RefQValues(2.5, 2.5))
						];
    structural_types[materials.ms][ductility.dcm] = [
					  	new StructuralType(structuralTypeNames.s46, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s47, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s48, new RefQValues(2, 2)),
					  	new StructuralType(structuralTypeNames.s49, new RefQValues(2.5, 2.5))
					  	];
    structural_types[materials.ms][ductility.dch] = [
					  	new StructuralType(structuralTypeNames.s46, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s47, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s48, new RefQValues(2, 2)),
					  	new StructuralType(structuralTypeNames.s49, new RefQValues(2.5, 2.5))
						];														    


	return structural_types;
}

function initStructSubTypes()
{
    var structural_subtypes = new Object();
    var num_of_ductility = getJsonLength(ductility);
    //objekt uporabljamo kot asociativni array
    structural_subtypes[structuralTypeNames.s17] = new Array(num_of_ductility);
   
   structural_subtypes[structuralTypeNames.s17][ductility.dcl] = [
                    	new StructuralType(structuralTypeNames.s17_1, new RefQValues(1.5, 1.5)),
                    	new StructuralType(structuralTypeNames.s17_2, new RefQValues(1.5, 1.5)),
                    	new StructuralType(structuralTypeNames.s17_3, new RefQValues(1.5, 1.5))
                      	];
    structural_subtypes[structuralTypeNames.s17][ductility.dcm] = [
                    	new StructuralType(structuralTypeNames.s17_1, new RefQValues(3.6, 3.3)),
                    	new StructuralType(structuralTypeNames.s17_2, new RefQValues(3, 3)),
                    	new StructuralType(structuralTypeNames.s17_3, new RefQValues(3, 3))
                      	];
    structural_subtypes[structuralTypeNames.s17][ductility.dch] = [
                    	new StructuralType(structuralTypeNames.s17_1, new RefQValues(5.4, 4.95)),
                    	new StructuralType(structuralTypeNames.s17_2, new RefQValues(4, 4)),
                    	new StructuralType(structuralTypeNames.s17_3, new RefQValues(4.4, 4.2))
                    	];
    
    return structural_subtypes;
}

//construction system object
function StructuralType(name, values)
{
	this.name = name;
	this.values = values;
}
/**
values are for regular height
plRegular - regular ground plan
plNotRegular - non regular ground plan
*/
function RefQValues(plRegular, plNotRegular)
{
    this.plRegular = plRegular;
    this.plNotRegular = plNotRegular;
}

function getJsonLength(json)
{
    var count = 0;
    for(var prop in json)
    {
        count++;
    }
    return count;
}

//ce so betonski sistemi in je izbran sistem med S4 in S7
//ali izbran eden od podsistemov S17
function isWallStructure(form)
{
    var strucTypes = form.slave;
    var strucTypeName = strucTypes.options[strucTypes.selectedIndex].innerHTML;
    if((form.master.selectedIndex == materials.rc && 
            (strucTypeName == structuralTypeNames.s4 || 
             strucTypeName == structuralTypeNames.s5 ||
             strucTypeName == structuralTypeNames.s6 || 
             strucTypeName == structuralTypeNames.s7)) || 
        (form.master.selectedIndex == materials.ss && 
             strucTypeName == structuralTypeNames.s17))
    {
        return true;
    }
    
    return false;
}

//ko izbrano/neizbrano Izpolnjuje zahtevo
function onFillsRequirement(form)
{
    structuralTypes[materials.ts] = generateTsTypes(form);
    changeList(form.master, false);
}

//generira lesene konstrukcijske sisteme z vrednostimi
//glede na to, ce izpolnjujejo zahtevo ali ne
function generateTsTypes(form)
{
    var fillsReq = false;
    if(form != null && form.TimberRegular.checked)
    {
        fillsReq = true;
    }
    
    var numOfductility = getJsonLength(ductility);
    var ts_Structuraltypes = new Array(numOfductility);
    
    ts_Structuraltypes[ductility.dcl] = [
					  	new StructuralType(structuralTypeNames.s36, new RefQValues(1.5, 1.5)),
					  	new StructuralType(structuralTypeNames.s37, new RefQValues(1.5, 1.5))
						];
   ts_Structuraltypes[ductility.dcm] = [
					  	new StructuralType(structuralTypeNames.s38, new RefQValues(2, 2)),
					  	new StructuralType(structuralTypeNames.s39, new RefQValues(2, 2)),
					  	new StructuralType(structuralTypeNames.s40, new RefQValues(2, 2)),
					  	new StructuralType(structuralTypeNames.s41, new RefQValues(2.5, 2.5))
						];
   ts_Structuraltypes[ductility.dch] = [
					  	new StructuralType(structuralTypeNames.s42, new RefQValues(3, 3)),
					  	new StructuralType(structuralTypeNames.s43, new RefQValues(3, 3))
						];
    var additional;
    if(fillsReq)
    {
        //izpolnjuje zahtevo
        additional = [
                      	new StructuralType(structuralTypeNames.s44, new RefQValues(4, 4)),
                      	new StructuralType(structuralTypeNames.s45, new RefQValues(5, 5))
                        ];
    }
    else
    {
        additional = [
                      	new StructuralType(structuralTypeNames.s44, new RefQValues(2.5, 2.5)),
                      	new StructuralType(structuralTypeNames.s45, new RefQValues(4, 4))
                        ];
    }
   
   	ts_Structuraltypes[ductility.dch] = ts_Structuraltypes[ductility.dch].concat(additional);
    
    return ts_Structuraltypes;
}